
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MySQL内核月报 2015.01-MySQL · 优化改进· 复制性能改进过程 / iVAN</title>

    <meta name="description" content="MySQL内核月报 2015.01-MySQL · 优化改进· 复制性能改进过程 前言 与oracle 不同,mysql 的主库与备库的同步是通过 binlog 实现的,而redo日志只做为mysql 实例的crash recovery使用.mysql在4.x 的时候放弃redo 的同步策略而引入 binlog的同步,一个重要原因是为了兼容其它非事务存储引擎,否则主备同步是没有办法进行的. redo 日志同步属于物理同步方法,简单直接,将修改的物理部分传送到备库执行,主备共用一致的 LSN,只要保证 LSN 相同即可,同一时刻,只能主库或备库一方接受写请求: binlog的同">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">MySQL内核月报 2015.01-MySQL · 优化改进· 复制性能改进过程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>前言</b></p>
<p>与oracle 不同，mysql 的主库与备库的同步是通过 binlog 实现的，而redo日志只做为mysql 实例的crash recovery使用。mysql在4.x 的时候放弃redo 的同步策略而引入 binlog的同步，一个重要原因是为了兼容其它非事务存储引擎，否则主备同步是没有办法进行的。</p>
<p>redo 日志同步属于物理同步方法，简单直接，将修改的物理部分传送到备库执行，主备共用一致的 LSN，只要保证 LSN 相同即可，同一时刻，只能主库或备库一方接受写请求； binlog的同步方法属于逻辑复制，分为statement 或 row 模式，其中statement记录的是SQL语句，Row 模式记录的是修改之前的记录与修改之后的记录，即前镜像与后镜像；备库通过binlog dump 协议拉取binlog,然后在备库执行。如果拉取的binlog是SQL语句，备库会走和主库相同的逻辑，如果是row 格式，则会调用存储引擎来执行相应的修改。</p>
<p>本文简单说明5.5到5.7的主备复制性能改进过程。</p>
<p>replication improvement (from 5.5 to 5.7)</p>
<p><b>(1) 5.5 中，binlog的同步是由两个线程执行的</b></p>
<p>io_thread: 根据binlog dump协议从主库拉取binlog, 并将binlog转存到本地的relaylog；</p>
<p>sql_thread: 读取relaylog，根据位点的先后顺序执行binlog event，进而将主库的修改同步到备库，达到主备一致的效果； 由于在主库的更新是由多个客户端执行的，所以当压力达到一定的程度时，备库单线程执行主库的binlog跟不上主库执行的速度，进而会产生延迟造成备库不可用，这也是分库的原因之一，其SQL线程的执行堆栈如下：</p>
<pre></pre>
<p>(2) <b>5.6 中，引入了多线程模式，在多线程模式下，其线程结构如下</b></p>
<p>io_thread: 同5.5</p>
<p>Coordinator_thread: 负责读取 relay log，将读取的binlog event以事务为单位分发到各个 worker thread 进行执行，并在必要时执行binlog event（Description_format_log_event， Rotate_log_event 等）。</p>
<p>worker_thread: 执行分配到的binlog event，各个线程之间互不影响；</p>
<p><b>多线程原理</b></p>
<p>sql_thread 的分发原理是依据当前事务所操作的数据库名称来进行分发，如果事务是跨数据库行为的，则需要等待已分配的该数据库的事务全部执行完毕，才会继续分发，其分配行为的伪码可以简单的描述如下：</p>
<pre></pre>
<p><b>需要注意的细节</b></p>
<ul>
<li>
<ul>
<li>内存的分配与释放。relay thread 每读取一个log_event, 则需要 malloc 一定的内存，在work线程执行完后，则需要free掉；</li>
<li>数据库名 与 worker 线程的绑定信息在一个hash表中进行维护，hash表以entry为单位，entry中记录当前entry所代表的数据库名，有多少个事务相关的已被分发，执行这些事务的worker thread等信息；</li>
<li>维护一个绑定信息的array , 在分发事务的时候，更新绑定信息，增加相应 entry-&gt;usage, 在执行完一个事务的时候，则需要减少相应的entry-&gt;usage；</li>
<li>slave worker 信息的维护，即每个 worker thread执行了哪些事务，执行到的位点是在哪，延迟是如何计算的，如果执行出错，mts_recovery_group 又是如何恢复的；</li>
<li>分配线程是以数据库名进行分发的，当一个实例中只有一个数据库的时候，不会对性能有提高，相反，由于增加额外的操作，性能还会有一点回退；</li>
<li>临时表的处理，临时表是和entry绑定在一起的，在执行的时候将entry的临时表挂在执行线程thd下面，但没有固化，如果在临时表操作期间，备库crash，则重启后备库会有错误；</li>
</ul>
</li>
</ul>
<p><b>总体上说，5.6 的并行复制打破了5.5 单线程的复制的行为，只是在单库下用处不大，并且5.6的并行复制的改动引入了一些重量级的bug</b></p>
<ul>
<li>
<ul>
<li>mysql slave sql thread memory leak (<a href="http://bugs.mysql.com/bug.php?id=71197" rel="external nofollow noreferrer">http://bugs.mysql.com/bug.php?id=71197</a>)</li>
<li>Relay log without xid_log_event may case parallel replication hang (<a href="http://bugs.mysql.com/bug.php?id=72794" rel="external nofollow noreferrer">http://bugs.mysql.com/bug.php?id=72794</a>)</li>
<li>Transaction lost when relay_log_info_repository=FILE and crashed (<a href="http://bugs.mysql.com/bug.php?id=73482" rel="external nofollow noreferrer">http://bugs.mysql.com/bug.php?id=73482</a>)</li>
</ul>
</li>
</ul>
<p>(3) 5.7中，并行复制的实现添加了另外一种并行的方式，即主库在 ordered_commit中的第二阶段的时候，将同一批commit的 binlog 打上一个相同的seqno标签，同一时间戳的事务在备库是可以同时执行的，因此大大简化了并行复制的逻辑，并打破了相同 DB 不能并行执行的限制。备库在执行时，具有同一seqno的事务在备库可以并行的执行，互不干扰，也不需要绑定信息，后一批seqno的事务需要等待前一批相同seqno的事务执行完后才可以执行。</p>
<p>详细实现可参考：<a href="http://bazaar.launchpad.net/~mysql/mysql-server/5.7/revision/6256" rel="external nofollow noreferrer">http://bazaar.launchpad.net/~mysql/mysql-server/5.7/revision/6256</a> 。</p>
<p>reference：<a href="http://geek.rohitkalhans.com/2013/09/enhancedMTS-deepdive.html" rel="external nofollow noreferrer">http://geek.rohitkalhans.com/2013/09/enhancedMTS-deepdive.html</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-02 03:28:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%95%b0%e6%8d%ae%e5%ba%93rds/" title="云数据库RDS">云数据库RDS</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>MySQL内核月报 2015.01-MySQL · 优化改进· 复制性能改进过程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn8vRAb.html" rel="bookmark">MySQL内核月报 2014&period;12-MySQL&CenterDot;　优化改进&CenterDot; GTID启动优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 GTID 可以说是 MySQL 5.6 版本的一个杀手级特性,它给主备复制带来了极大的便利,RDS只读实例就是强依赖于这个特性.然而GTID在给我们带来便利的同时,也埋下了许多坑,最近几期内核月报中GTID的频繁出现也说明了这一点,对其我们可以说是既爱又恨. GTID 并不是免费午餐,要使用它是要有代价的,为了保证GTID这个体系能够运转起来,需要做许多相关的工作,比如binlog里每个事务要多记 gtid_event 这种事件.写binlog的时候要生成 gtid.要维护几个GTID集合			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQWAnp.html" rel="bookmark">MySQL内核月报 2015&period;03-MySQL &CenterDot; 性能优化&CenterDot; 5&period;7&period;6 InnoDB page flush 优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上期的月报中,我们已经详细介绍了Oracle MySQL以及社区分支最新的对InnoDB page flush的优化.在最近release的5.7.6版本中又有了进一步的改进.主要包括以下几点修改 修改一.更精确的loop时间 Page cleaner每做srv_flushing_avg_loops次flush后,会去计算刷脏和Redo LSN增长的速度.由于每次Page cleaner的工作量是自适应的,一次flush操作的时间可能超过1秒. 在新版本中,统一采用当前时间和上次更新速率的时间			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJ3Wvp.html" rel="bookmark">MySQL内核月报 2015&period;01-MySQL &CenterDot; 性能优化&CenterDot; 启用GTID场景的性能问题及优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 MySQL从5.6版本开始支持GTID特性,也就是所谓全局事务ID,在整个复制拓扑结构内,每个事务拥有自己全局唯一标识.GTID包含两个部分,一部分是实例的UUID,另一部分是实例内递增的整数. GTID的分配包含两种方式,一种是自动分配,另外一种是显式设置session.gtid_next,下面简单介绍下这两种方式: 自动分配 如果没有设置session级别的变量gtid_next,所有事务都走自动分配逻辑.分配GTID发生在GROUP COMMIT的第一个阶段,也就是flush sta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZBXmaz.html" rel="bookmark">MySQL内核月报 2015&period;01-MySQL &CenterDot; 性能优化&CenterDot; Group Commit优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 关于Group Commit网上的资料其实已经足够多了,我这里只简单的介绍一下. 众所周知,在MySQL5.6之前的版本,由于引入了Binlog/InnoDB的XA,Binlog的写入和InnoDB commit完全串行化执行,大概的执行序列如下: 当sync_binlog=1时,很明显上述的第二步会成为瓶颈,而且还是持有全局大锁,这也是为什么性能会急剧下降. 很快Mariadb就提出了一个Binlog Group Commit方案,即在准备写入Binlog时,维持一个队列,最早进入队列的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8GaEZM.html" rel="bookmark">MySQL内核月报 2015&period;03-MySQL &CenterDot; 优化限制&CenterDot; MySQL index&lowbar;condition&lowbar;pushdown</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 MySQL 5.6 开始支持index_condition_pushdown特性,即server层把可以在index进行filter的谓词传递给引擎层完成过滤,然后结果返回到server. 工作方式 下面看一下InnoDB的处理方式: 通过设置set global optimizer_switch= &quot;index_condition_pushdown=ON&quot;来启用这个特性. 例如: 1. 评估 在执行计划评估阶段,通过push_index_cond函数把index filter谓			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0RGQ7z.html" rel="bookmark">MySQL内核月报 2015&period;02-MySQL &CenterDot; 性能优化&CenterDot; InnoDB buffer pool flush策略漫谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 我们知道InnoDB使用buffer pool来缓存从磁盘读取到内存的数据页.buffer pool通常由数个内存块加上一组控制结构体对象组成.内存块的个数取决于buffer pool instance的个数,不过在5.7版本中开始默认以128M(可配置)的chunk单位分配内存块,这样做的目的是为了支持buffer pool的在线动态调整大小. Buffer pool的每个内存块通过mmap的方式分配内存,因此你会发现,在实例启动时虚存很高,而物理内存很低.这些大片的内存块又按照16KB			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYdPKVb.html" rel="bookmark">MySQL内核月报 2015&period;02-MySQL &CenterDot; 答疑释惑&CenterDot; InnoDB丢失自增值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 在上一期的月报中,我们在InnoDB自增列重复值问题 中提到,InnoDB 自增列在重启后会丢失,因为MySQL没有持久化自增值,平时是存在内存表对象中的.如果实例重启的话,内存值丢失,其初始化过程是做了一个类似 select max(id) + 1 操作.实际上存在另外一种场景,实例即使不重启,也会导致自增值丢失. 问题说明 实例运行过种中,InnoDB表自增值是存储在表对象中的,表对象又是放在缓存中的,如果表太多而不能全部放在缓存中的话,老的表就会被置换出来,这种被置换出来的表下次再使			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2P753p.html" rel="bookmark">MySQL内核月报 2015&period;02-MySQL &CenterDot; 答疑释惑&CenterDot; 5&period;5 和 5&period;6 时间类型兼容问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 5.6.4及以上版本,datetime,time,timestamp的Binlog在5.6.4以下的备库无法执行,如: 5.6.16(主库): create table t1(t datetime default now()); insert into t1 values(now()); 5.5.18(备库): show slave stauts\G ; 此时备库中断,报错:Last_Errno: 1677, 描述信息:Last_Error: Column 1 of table t1.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYdv8eb.html" rel="bookmark">MySQL内核月报 2015&period;03-MySQL &CenterDot; 捉虫动态&CenterDot; pid file丢失问题分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现象 mysql5.5,通过命令show variables like '%pid_file%'; 可以查到pid文件位置,例如/home/mysql/xx.pid.但发现在此目录下找不到此pid文件. 背景知识 mysql pid文件记录的是当前mysqld进程的pid. 通过mysqld_safe启动mysqld时,mysqld_safe会检查PID文件,未指定PID文件时,pid文件默认名为$DATADIR/`hostname`.pid pid文件不存在,不做处理 文件存在,且pid已占用			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP8lpN.html" rel="bookmark" class="title">硬盘安装Windows 8系统图文教程</a>
					<div>
						没有光驱.没有光盘.没有U盘,照样安装一个全新的Windows 8!什么?你不信?那就看看软件小品如何教你使用硬盘安装一个全新的Windows 8!看了这篇图文并茂的硬盘安装Window8详细教程,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWGdXM.html" rel="bookmark" class="title">php读取eml实例、php解析eml、eml解析成网页</a>
					<div>
						php读取eml实例,本实例可以将导出eml文件解析成正文,并且可以将附件保存到服务器.不多说直接贴代码了. 如果你觉得此代码不错,请点个赞.谢谢~~~~ ; define(EML_FILE_PATH ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKNqZz.html" rel="bookmark" class="title">在DotNet里面利用XML</a>
					<div>
						xml 呵呵,有意思,听过一个笑话,说德国一个老头,是个聋子,在如厕时,突然苏联战机空袭,虽然房屋倒塌,可是全家人都没有事情,家里人扒开卫生间的墙壁,发现老头在那儿乐,说:我一拉抽水马桶的绳,屋就倒了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4L2Ap.html" rel="bookmark" class="title">2009年国内软件测试的十大热点预测</a>
					<div>
						2009年悄悄地来到了,送走了艰难的.折腾的2008年.人们对2009年会充满更多的期望,9是一个吉祥的数字,天长地久,而且农历是牛年,牛年更牛. 到了2009年,该为软件测试写点什么.顺民意,预测一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7LBAb.html" rel="bookmark" class="title">胡乱理解ADO&period;NET&lpar;四&rpar;</a>
					<div>
						在上两篇文章中,对于dataset做了个简单的探讨.很多次提到,可以把dataset看作是内存中的数据库.既然是数据库,那么首要任务就是存储数据用的.而之前,我所举的的例子都是手工往dataset里添 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwl3R5b.html" rel="bookmark" class="title">Photoshop实例解析曲线工具的使用技巧</a>
					<div>
						  Photoshop实例解析曲线工具的使用技巧           大部分时间,曲线更能都是调亮度神器,都是调整图像的明暗度,而且好像还总结了一些规律,比如最常见的S曲线和明度曲线暗度曲线等,如果想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2yO7M.html" rel="bookmark" class="title">Photoshop制作微缩景观图片</a>
					<div>
						喜欢摄影的朋友都知道,在拍摄细小及微观物体的时候如花朵,蜜蜂等,我们把光圈调得特别大.这样拍出的片子焦距很小.主体前后都会模糊.下面的教程正是用PS来模拟这种效果. 原图 最终效果 1.选择照片运行p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24WKBp.html" rel="bookmark" class="title">word无法打开现有内容&lpar;normal&period;dot&rpar;怎么办</a>
					<div>
						  有时候我们在打开word或是其它office组件时提示word无法打开现有内容(normal.dot)等问题,那应该怎么办呢?下面小编就给大家提供三种方法来解决这个问题. 来了解一下有原理先!no ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKmvoM.html" rel="bookmark" class="title">特殊符号怎么打出来&quest;</a>
					<div>
						经常看到很多朋友的QQ昵称拥有很多特俗符号是不是感觉很个性呢?对于很多电脑爱好者朋友来说,大量的特殊符号相信很少有朋友能打的全.下面本文将与大家分享下如何打出各种个性特殊符号及常用的特殊符号大全. 特 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZ5q2z.html" rel="bookmark" class="title">为什么需要用户角色模型</a>
					<div>
						已经工作的你们,跟公司领导或是开发.销售等其他人讨论产品的设计问题,这么两个问题是不是常常听到:&quot;我也是用户啊,在我看来xxx功能提好的啊&quot;,&quot;假如用户需要xxx功能怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z3Oob.html" rel="bookmark" class="title">android-怎么形成编程思想，写代码的时候不知道该干什么</a>
					<div>
						问题描述 怎么形成编程思想,写代码的时候不知道该干什么 最近在看视频学Android,可以看懂视频中的大多数代码,但是让我自己写就有点难了,写完这一步不知道下一步该干什么,甚至是根本不知道该怎么下手, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EVorM.html" rel="bookmark" class="title">IOS中使用本地通知为你的APP添加提示用户功能</a>
					<div>
						IOS中使用本地通知为你的APP添加提示用户功能 首先,我们先要明白一个概念,这里的本地通知是UILocalNotification类,和系统的NSNotificationCenter通知中心是完全不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E489M.html" rel="bookmark" class="title">vs2005与MC50打包的问题&period;&period;&period;请高人指导一下&period;&period;分嫌少我可以再加</a>
					<div>
						问题描述 现在程序已经写完,程序也部署到PDA中.但我怕PDA从置后程序就没有了..所以就把程序放到了PDA的Application文件夹中.这是一个缓存的文件夹.但从置后.还需求.NET的一些包.. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrNDWM.html" rel="bookmark" class="title">如何在ASP&period;NET中使用JavaScript脚本</a>
					<div>
						一)简单点的如要在一个按钮上增加认证脚本,可以这样&lt;%@ Page Language=&quot;C#&quot; %&gt;&lt;SCRIPT language=&quot;javascri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kGqNM.html" rel="bookmark" class="title">政策松动 医药电商市场回春</a>
					<div>
						火红6月,随着处方药网络禁售政策的松动,原本踟蹰慢行的医药电商释放出了苏醒的信号. 今年5月末,国家食品药品监督管理总局(以下简称为国家食药监总局)发布&lt;互联网食品药品经营监督管理办法(征求意见 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR3eVz.html" rel="bookmark" class="title">vscode-visualstudio code&period;  c&plus;&plus;智能提示</a>
					<div>
						问题描述 visualstudio code. c++智能提示 1C 如题怎么能让vscode智能提示C++代码?还有写的过程中有错误会画红线,这些都是怎么做到的?求详细 解决方案 理论上可以写插件实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lvYjb.html" rel="bookmark" class="title">Use the heap for dynamic storage</a>
					<div>
						在C中, 本地变量存储在进程的stack内存区域. 当函数执行完后, 函数体内的本地变量占用的内存会自动释放掉. 在Linux中使用ulimit -a可以查看到stack的限制, 也可以通过/etc/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEEQEM.html" rel="bookmark" class="title">3d矩阵-矩阵求解，请高手指点？可支付宝给红包</a>
					<div>
						问题描述 矩阵求解,请高手指点?可支付宝给红包 本人刚接触矩阵,什么也不懂!这上面的字母都代表什么意思啊?如果我现在要对这两组数据进行对冲后.取得一个平衡值,该怎么取 解决方案 矩阵的本质就是线性方程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeKZKb.html" rel="bookmark" class="title">&commat;数据结构大神：递归遍历二叉树，建立树的代码 为什么错&quest;</a>
					<div>
						问题描述 @数据结构大神:递归遍历二叉树,建立树的代码 为什么错? //创建-输入-打印-递归 # include&lt;stdio.h&gt; # include&lt;stdlib.h&gt; # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRdA3b.html" rel="bookmark" class="title">使用maven编译Java项目</a>
					<div>
						综述 本文演示了用Maven编译Java项目 需要 时间:15分钟 文本编辑器或者IDE JDK 6 或者更高版本 创建项目 本例主要为了展示Maven,所以Java的项目力求简单. 创建项目结构 选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7DJPp.html" rel="bookmark" class="title">MySQL中lock tables和unlock tables浅析</a>
					<div>
						MySQL中lock tables和unlock tables浅析   在MySQL中提供了锁定表(lock tables)和解锁表(unlock tables)的语法功能,ORACLE与SQL Se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRY18b.html" rel="bookmark" class="title">Mycat（4）：消息表mysql数据库分表实践</a>
					<div>
						本文的原文连接是: http://blog.csdn.net/freewebsys/article/details/46882777 未经博主允许不得转载. 1,业务需求 比如一个社交软件,比如像腾讯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydX6db.html" rel="bookmark" class="title">对象-java中有关TreeSet的一个小疑问</a>
					<div>
						问题描述 java中有关TreeSet的一个小疑问 看书上说java所有集合框架的具体类都至少有两种构造方式,一种是无参构造方法,一种是用另一个已有的容器来构造. 比如先前已经有了一个HashSet类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAP2wp.html" rel="bookmark" class="title">Android编程实现只显示图片一部分的方法&lowbar;Android</a>
					<div>
						本文实例讲述了Android编程实现只显示图片一部分的方法.分享给大家供大家参考,具体如下: 在Android应用程序中加载一张图片,然后把它显示出来这是一件非常容易的事情,那怎么才能显示一张图片的一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rgYgz.html" rel="bookmark" class="title">完美2D回合动作网游《神雕侠侣》今内测</a>
					<div>
						完美世界旗下首款2D回合动作网游&lt;神雕侠侣&gt;今日正式内测.&lt;神雕侠侣&gt;是游戏行业内首款采用&quot;双引擎&quot;的网游,可以轻松实现千人同屏,首创轻功玩法,并在业内首次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXZKeb.html" rel="bookmark" class="title">javascript-如何按24小时查询，按周，按月查询</a>
					<div>
						问题描述 如何按24小时查询,按周,按月查询 选择datebox中的startDate,如何设置一个按周查询的按钮,点了之后endDate直接变为七天后啊? 解决方案 查询24小时					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEK5QJp.html" rel="bookmark" class="title">struts2标签 实现2级下拉列表该怎么实现</a>
					<div>
						问题描述 通过&lt;s:iterator&gt;遍历list&lt;KindEntity&gt;获取一级列表,并全部显示,然后通过遍历出的值获取2级下拉列表 改怎么实现呢?我这么写有问题:&lt;s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEK3Dop.html" rel="bookmark" class="title">《响应式Web设计实践》一1&period;1　我们错在哪里</a>
					<div>
						1.1 我们错在哪里 响应式Web设计实践 观察我年幼的女儿们玩耍的过程,对我来说是一段启发性的经历.每当她们得到一个新的玩具,她们总会试着用玩旧玩具的方法来玩新玩具.她们寻找着新玩具和旧玩具之间相似 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1jdob.html" rel="bookmark" class="title">简单了解Backbone&period;js的Model模型以及View视图的源码&lowbar;基础知识</a>
					<div>
						Backbone.Model 今天我们先来谈谈Backbone.js MVC 中的 M , Model是backbone的核心部分,包含着页面展示内容的数据,还有围绕着数据操作的各种 转换,校验,计算 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKDlvz.html" rel="bookmark" class="title">三星平板Tab S2手写输入法功能如何切换&quest;&lpar;T810&comma;T710&rpar;</a>
					<div>
						手写输入法是三星平板电脑自带的一个功能了我们只需在在填写信息的界面中进行切换输入法了,具体的细节如下所示. 1.点击手机界面中的[应用程序]效果如下所示  2.之后我们再找到[设定]选项,效果如下.  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
